/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 236 by dpavlin, Wed Jan 26 12:16:23 2011 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
         ls /var/lib/lxc/*/config | cut -d/ -f5  
         exit 1  
 fi  
30    
31  rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  echo "$name rootfs $rootfs"                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
38    
39    lxc_rootfs() {
40            grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56    lxc_status() {
57            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58                    boot="-"
59                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
60                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61            done ) | column -t
62    }
63    
64    
65    cleanup_init_scripts() {
66            rootfs=$(lxc_rootfs $1)
67    
68            ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                    $rootfs/etc/rc?.d/*umountfs \
71                    $rootfs/etc/rc?.d/*umountroot \
72                    $rootfs/etc/rc?.d/*hwclock* \
73                    $rootfs/etc/rc?.d/*udev* \
74            2>/dev/null | xargs -i rm -v {}
75    
76            echo $1 > $rootfs/etc/hostname
77            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
78    }
79    
80    
81    setup_inittab() {
82            rootfs=$(lxc_rootfs $1)
83            remove=$2
84            add=$3
85    
86            # let container respond to kill -SIGPWR
87            inittab=$rootfs/etc/inittab
88            if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
89                    grep -v "$remove" ${inittab} > ${inittab}.new
90                    echo $add >> ${inittab}.new
91                    mv ${inittab}.new ${inittab}
92                    echo "$inittab modified with $add"
93            fi
94    }
95    
96    
97    lxc_log() {
98            echo `date +%Y-%m-%dT%H:%M:%S` $*
99    }
100    
101    
102    lxc_kill() {
103            name=$1
104            sig=$2
105    
106            init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
107            if [ -z "$init_pid" ] ; then
108                    lxc-info -n $name
109                    exit 1
110            fi
111            lxc_log "$name kill $sig $init_pid"
112            /bin/kill $sig $init_pid
113    }
114    
115    lxc_stop() {
116            lxc_log "$name stop"
117            lxc_kill $name -SIGPWR
118            lxc-wait -n $name -s STOPPED
119            lxc_log "$name stoped"
120    #       rm -f /var/lib/lxc/${name}/on_boot
121    }
122    
123    
124    lxc_start() {
125            name=$1
126            rootfs=$(lxc_rootfs $1)
127    
128            if [ ! -e $rootfs ] ; then
129                    echo "ERROR $name rootfs $rootfs not found"
130                    return
131            fi
132    
133  # cleanup init scripts which don't work in containers          if ! lxc-info -n $name | grep RUNNING ; then
134  ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}                  lxc_log "$name start"
135  ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}                  lxc-start -n $name -o /tmp/${name}.log -d
136  ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}                  lxc-wait  -n $name -s RUNNING
137                    lxc-info  -n $name
138                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
139            fi
140    }
141    
142  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_watchdog() {
143    name=$1
144    rootfs=$(lxc_rootfs $1)
145    
146  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
147          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
148          inotifywait -qqt 300 ${vps_utmp}          tasks=`wc -l < /cgroup/${name}/tasks`
149          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          stop_on=1 # init
150            sulogins=`lxc-ps --name backuppc | grep sulogin | wc -l`
151            if [ "$sulogins" -gt 0 ] ; then
152                    stop_on=`expr $stop_on + $sulogins`
153            fi
154    
155            test -z "$tasks" && exit 1
156            if [ "$tasks" -eq $stop_on ]; then
157    
158                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
159                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
160    
161                  case $runlevel in                  case $runlevel in
162                  N*)                  N*)
163                          # nothing for new boot state                          # nothing for new boot state
164                  ;;                  ;;
165                  ??0)                  ??0)
166                          echo "$name halt"                          lxc_log "$name halt"
167                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
168                            lxc-wait -n ${name} -s STOPPED
169                          break                          break
170                  ;;                  ;;
171                  ??6)                  ??6)
172                          echo "$name reboot";                          lxc_log "$name reboot";
173                          lxc-stop -n ${name}                          lxc-stop -n ${name}
174                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
175                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
176                  ;;                  ;;
177                  *)                  *)
# Line 54  while true; do Line 180  while true; do
180                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
181                  ;;                  ;;
182                  esac                  esac
183            else
184                    lxc_log "$name $tasks tasks $sulogins console"
185          fi          fi
186    
187            # time of 5 minutes on it JUST IN CASE...
188            inotifywait -qqt 300 ${vps_utmp}
189  done  done
190    
191    lxc_log "$name watchdog exited"
192    
193    }
194    
195    
196    usage() {
197            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
198            exit 3
199    }
200    
201    command_on_lxc() {
202    command=$1
203    shift
204    
205    echo "# $command $1"
206    
207    case "$command" in
208    
209    start)
210            lxc_exists $1
211            cleanup_init_scripts $1
212            setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
213            setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
214            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
215            lxc_start $1
216            # give container 5 seconds to start more than one process
217            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
218            ;;
219    stop|halt)
220            lxc_exists $1
221            lxc_stop $1
222            ;;
223    reload|force-reload|restart|reboot)
224            lxc_kill $1 -SIGINT
225            ;;
226    watchdog)
227            lxc_watchdog $1
228            ;;
229    boot)
230            echo $1 > /var/lib/lxc/$1/on_boot
231            ;;
232    disable)
233            echo -n > /var/lib/lxc/$1/on_boot
234            ;;
235    *)
236            usage
237            ;;
238    
239    esac
240    
241    }
242    
243    command=$1
244    test -z "$command" && usage
245    test "$command" = "status" && lxc_status && exit
246    shift
247    
248    if [ -z "$1" ] ; then
249            ls /var/lib/lxc/*/on_boot | while read path ; do
250                    name=`echo $path | cut -d/ -f5`
251                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
252                            command_on_lxc $command $name
253                    else
254                            echo "# skip $command $name"
255                    fi
256            done
257    else
258            while [ ! -z "$1" ] ; do
259                    command_on_lxc $command $1
260                    shift
261            done
262    fi
263    

Legend:
Removed from v.178  
changed lines
  Added in v.236

  ViewVC Help
Powered by ViewVC 1.1.26